<template>
  <div class="monster-list-container">
    <!-- MONSTERS LIST CONTAINER -->
      <ul>
        <!-- ON HOVER WHEN WIDTH BIGGER THEN 1160PX CARD FLIP, ON CLICK OPENS DEPAIL PAGE OF RESPECTIVE MONSTER -->
        <li v-for="(monster, index) in setMonstersList"
            :key="index"
            @mouseover="handleMonsterIndex = index"
            @mouseout="handleMonsterIndex = null"
            @click="setActiveMonster(monster, index)"
            :class="handleCardHeight()">
          <router-link id="router-link-to-detail" :to="monster.index">
            <div class="card-global-sytle card-front-side" v-show="handleMonsterIndex !== index" :class="handleCardTransition()">
              <div class="monster-name">{{ monster.name }}</div>
              <div class="monster-image" v-if="!hideMonsterImage">
                <img 
                  v-if="monster.type != 'swarm of Tiny beasts'"
                  :src="`https://mk0thealpinedmusc1ub.kinstacdn.com/wp-content/uploads/2020/09/${monster.type.charAt(0).toUpperCase() + monster.type.slice(1)}.png`"/>
                <img 
                  v-if="monster.type == 'swarm of Tiny beasts'"
                  src="https://mk0thealpinedmusc1ub.kinstacdn.com/wp-content/uploads/2020/09/Beast.png"/>
              </div>
              <div class="monster-data">
                <div class="monster-stats">
                  <div>
                    <i class="fas fa-shield-alt"></i>
                    {{ monster.armor_class }}
                  </div>
                  <div>
                    <i class="fas fa-heartbeat"></i>
                    {{ monster.hit_points }}
                  </div>
                  <div>
                    <i class="fas fa-dice-d20"></i>
                    {{ monster.hit_dice }}
                  </div>
                </div>
              </div>            
            </div>
            <div class="card-global-sytle card-back-side" v-show="handleMonsterIndex === index" :class="!handleCardTransition()">
              <div class="monster-type-area">{{ monster.type }}</div>
              <div class="monster-specs">
                <div class="monster-specs-global-style"><label>SIZE</label> {{ monster.size }}</div>
                <div class="monster-specs-global-style"><label>STRENGTH</label> {{ monster.strength }}</div>
                <div class="monster-specs-global-style"><label>DEXTERITY</label> {{ monster.dexterity }}</div>
                <div class="monster-specs-global-style"><label>INTELLIGENCE</label> {{ monster.intelligence }}</div>
                <div class="monster-specs-global-style"><label>WISDOM</label> {{ monster.wisdom }}</div>
                <div class="monster-specs-global-style"><label>CHARISMA</label> {{ monster.charisma }}</div>
                <div class="monster-specs-global-style monster-alignment-languages"><label>ALIGNEMENT</label> {{ monster.alignment }}</div>
                <div class="monster-specs-global-style monster-alignment-languages" v-if="monster.languages != ''"><label>LANGUAGES</label> {{ monster.languages }}</div>              
              </div>
            </div>
          </router-link>
        </li>
      </ul>
  </div>
</template>

<script lang="ts">
import Vue from "vue";
import MonstersListService from "@/services/MonstersListService";
import Monster from "@/types/Monster";

import EventBus from "../EventBus";

 const CARD_FRONT_SIDE_TRANSITION_CLASS = 'card-front-side-transition'
 const CARD_BACK_SIDE_TRANSITION_CLASS = 'card-back-side-transition'
 const CARD_FRONT_SIDE_SIZE_CLASS = 'card-front-side-size'


export default Vue.extend({
  data() {
    return {
      monsters: [] as Monster[],
      setMonstersList: [{}],
      handleMonsterIndex: null,
      hideMonsterImage: false,
      windowWidth: 0
    }
  },

  methods: {
    // GET LIST OF ALL MONSTERS
    getAllMonsters() {
      const monstersList: any[] = []
      MonstersListService.getAll()
        .then((response) => {
          this.monsters = response.data.results.map((index: any) => index.index)
          for(let i = 0; i < this.monsters.length; i++) {
            MonstersListService.get(this.monsters[i])
            .then((monstersResults) => {
              monstersList.push(monstersResults.data)
            })
          }
        })
        .catch((e) => {
          console.log(e);
        });

      return monstersList
    },
    //  GET MONSTERS FILTERED BY CHOOSEN TYPE
    getAllMonstersFiltered(filterByType: any) {
      const monstersList: any[] = []
      MonstersListService.getAll()
        .then((response) => {
          this.monsters = response.data.results.map((index: any) => index.index)
          for(let i = 0; i < this.monsters.length; i++) {
            MonstersListService.get(this.monsters[i])
            .then((monstersResults) => {
            if(!filterByType) {
                monstersList.push(monstersResults.data)
              } else {
                if(monstersResults.data.type == filterByType) {
                  monstersList.push(monstersResults.data)
                }
              }
            })
          }
        })
        .catch((e) => {
          console.log(e);
        });

      return monstersList
    },
    // CARD FLIP CLASS ON HOVER
    handleCardTransition() {
      if(this.handleMonsterIndex !== null) {
        return CARD_FRONT_SIDE_TRANSITION_CLASS
      } else {
        return CARD_BACK_SIDE_TRANSITION_CLASS
      }
    },
    // WHEN WIDTH LOWER THEN 1160PX CARD ADJUSTS
    handleCardHeight() {
      this.windowWidth = window.innerWidth
      if(this.windowWidth < 1160) {
        this.hideMonsterImage = true
        this.handleMonsterIndex = null
        return CARD_FRONT_SIDE_SIZE_CLASS
      } else {
        return this.hideMonsterImage = false
      }
    },
    // ON CLICK GO TO RESPECTIVE MONSTER DETAIL PAGE, BASED ON THE INDEX
    setActiveMonster(monster: Monster) {
      MonstersListService.monsterSelected(monster.index)
      .then((monster) => {
        monster.data.index
      })
    },
    // ON CLICK SORTS MONSTER LIST ASC/DESC
    sortMonstersList() {
      EventBus.$on('sortMonstersList', (sortMonsters: any) => {        
        if(sortMonsters == true) {
          return this.setMonstersList.sort((a: any, b: any) => (a.name < b.name) ? -1 : 1)
        } else {
          return this.setMonstersList.sort((a: any, b: any) => (a.name < b.name) ? 1 : -1)
        }
      })
    },
  },
  
  created() {
    this.setMonstersList = this.getAllMonsters()
    },

  mounted() {
    // WAITS FOR THE CLICK TO APPLY THE CHOOSEN FILTER
    EventBus.$on('filterListByType', (selectedType: any) => {
      this.setMonstersList = this.getAllMonstersFiltered(selectedType)
    }),
    this.sortMonstersList()
    this.handleCardHeight()
    window.addEventListener('resize', () => {
      this.handleCardHeight()
    })
  }
})
</script>

<style scoped>
.monster-list-container {
  overflow-y: auto;
  border-top: 0.2em solid #000000;
}

 ul {
  display: flex;
  flex-direction: row;
  flex-wrap: wrap;
  justify-content: center;
  padding: 0;
  margin: 0;
  list-style: none;
}

li {
  position: relative;
  margin: 1.6em;
  margin-bottom: 0;
  width: 15em;
  height: 20em;
  background-color: #ffffffa4;
  border: solid 0.2em #7a0000;
  border-radius: 0.5em;
  color: #ffff;
  user-select: none;
  cursor: pointer;
  transition: 0.6s;
}

#router-link-to-detail {
  text-decoration: none;
  color: inherit;
}

.card-global-sytle {
  position: absolute;
  left: 0;
  top: 0;
  right: 0;
  bottom: 0;
  background-color: #7a0000;
  border: 0.2em solid #ffffff;
  border-radius: 0.5em;  
}

.card-front-side-size {
  height: 7em;
}

.monster-name {
  display: flex;
  flex-direction: column;
  justify-content: center;
  height: 2.55em;
  font-weight: bold;
}

.monster-image {
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  height: 14em;
  background-color: #ffffff;
  border: 0.2em solid #7a0000;
}

.monster-image img {
  width: 11em;
}

.monster-stats {
  display: flex;
  flex-direction: row;
  justify-content: center;
  align-items: center;
  height: 2em;
}

.monster-stats div {
  display: flex;
  justify-content: center;
  padding: 0.2em;
  margin: 0.8em;
}

.monster-stats i {
  margin-right: 0.15em;
}

.card-back-side {
  background-color: #7a0000;
  background-image: url("https://www.transparenttextures.com/patterns/black-thread.png");
  transform: rotateY(180deg);
}

.monster-type-area {
  display: flex;
  flex-direction: column;
  justify-content: center;
  height: 2.55em;
  font-weight: bold;
  text-transform: uppercase;
}
.monster-specs {
  display: flex;
  flex-direction: row;
  flex-wrap: wrap;
  justify-content: center;
  align-content: center;
}

.monster-specs-global-style {
  display: flex;
  flex-direction: column;
  padding: 0.1em;
  margin: 0.3em;
  width: 8em;
  background-color: #ffffff;
  border-top-right-radius: 0.65em;
  border-top-left-radius: 0.65em;
  color: #000000;
  font-size: 0.8em;
}

.monster-alignment-languages {
  padding: 0.3em;
  margin-top: 0.75em;
  min-width: 16.3em;
  border-top-right-radius: 0em;
  border-top-left-radius: 0em;
  border-bottom-right-radius: 0.65em;
  border-bottom-left-radius: 0.65em;
}

.monster-specs-global-style label {
  font-weight: bold;
  cursor: pointer;
}


/* DYNAMIC STYLE AREA */
@media only screen and  (max-width: 1024px) {
  /* .monster-list-container {
    min-height: 85em;
  } */

  li {
    font-size: 1.5em;
  }
}

@media only screen and  (min-width: 1160px) {
  li:hover {
    transition: 0.9s;
    transform: rotateY(180deg);
  }
}

</style>
